//"ekspZK.sci","Eksport ZK - include",12006,0,2.0.1,SYSTEM
//"Eksport - include",12005,14,16
/////////////////////////////////////////
// "Eksport ZK - include"
// ekspZK.sci
/////////////////////////////////////////

#include "Eksport kontrahentw - include"
#include "Eksport towarw - include"
#include "Eksport ZK III - include"
#include "Integracja ZK do FK - include3"

// dostpne opcje wywoania fukcji EksportZK()
#define ROWNOLEGLE_KSIEG_MAG		0x1
#define NIE_EKSP_OZNAK				0x2

int isSD = (Mid(eksport.GetIniSectionName(),1,27) == "Eksport dokumentow ZK do SD")

Obliczenia obl
int DECLARE PrintError(String msg)

//---------------------------------------------------------------------------
int Sub EksportZK(long idDK, int iOpcje)
//---------------------------------------------------------------------------
// zmienne globalne: BaseDK basDK, BaseDP basDP, InfoVat StVat(6)

	EksportZK = 1

	int err
	int bKorekta = 0, bRozliczony
	int nCount = 1
	int nPozycja = 0
	int iStVat
	string sRejVat
	string sRejVatNazw
	int iRejVatRodz
	int iPom, iPomStVat, nRes
	int index = 1
	int i
	int iSubtyp
	float sumanetto, sumavat
	float nettoNP, vatNP, wnettoNP, wbruttoNP

	int nLastZap = 0
	
	float dKwota, dKwotaWal, dKurs, dKursDoch
	String strTmp, symbolFK, obslugujJak

	string sRej, sRejestry, sJPK_V7
	string strRex = "{*}naliczonyNP/={(:z)}{*}"

	long lSuper
	long lABC
	
	strOpis = ""

	long tIdMG(1)
	int dokanul
	BaseZZ basZZ
	
	if basDK.GetRecById(idDK) then PrintError("Brak takiego rekordu w bazie DK")
	dokanul = iif(Toint(basDK.GetField(funZnaki("subtypi")))== ANUL,1,0)

	// sprawdzamy typ dokumentu
	Select Case Toint(basDK.GetField(funZnaki("subtypi")))
		Case FVZ, FKZ, RUZ, RKZ, DIM, DKM, ZRZ, ZRK, FVR, FKR, ANUL, FVM, FKM, FZZ, ZKZ, WNT, FWZ, WKZ, WNK, ZVW, ZWK
		Case Else
			EksportZK = 0 // pomijamy
			eksport.AddError("Nie mona wyeksportowa dokumentu " + basDK.GetField("kod") + ". Dokument tego typu jest nieeksportowalny.")
	EndSelect
	if ( EksportZK == 0 ) then Exit

	if !dokanul && !CzyEkspBrakSchematu(basDK.GetField("schemat"), basDK.GetField("kod")) then
		EksportZK = 0 // pomijamy
		Exit
	endif

	if !dokanul && !CzyEkspBlednySchemat(basDK.GetField("schemat"), basDK.GetField("kod"), ToInt(basDK.GetField(funZnaki("subtypi")))) then
		EksportZK = 0 // pomijamy
		Exit
	endif

	basDK2.SetKey("numer")
	basDK2.SetKeySeg(funZnaki("typi"), Field(101))	// KARTAdkTYP
	basDK2.SetKeySeg("kod", basDK.GetField("typ_dk"))
	if !dokanul && !CzyEkspBrakTypDK(basDK2.GetRec(EQ), basDK.GetField("kod"), ToInt(basDK.GetField(funZnaki("subtypi"))),basDK.GetField("typ_dk")) then
		EksportZK = 0 // pomijamy
		Exit
	endif

	symbolFK = basDK2.GetField("khadres")
	obslugujJak = basDK2.GetField("khkodpocz")
	sRejestry = basDK2.GetField("odnazwa")
	dKurs = basDK.GetField("kurs")
	dKursDoch = basDK.GetField("kursDoch")
	

	//sprawdzamy czy faktury walutowe nie sa eksportowane jako stare( nie walutowe) do FK
	if(iSubtyp == ZVW || iSubtyp == ZWK)  && (obslugujJak != "FWZ" && obslugujJak != "FWZK") && (dKurs != dKursDoch) then
		nRes = 1
	else
		nRes = 0
	endif		
	if !dokanul && !CzyEkspBlednyTypFK(nRes, basDK.GetField("kod")) then
		EksportZK = 0 // pomijamy
		Exit
	endif
/*
	//sprawdzamy czy dokumenty zlotowkowe nie sa eksportowane jako faktura walutowa
	if (obslugujJak == "FWZ" || obslugujJak == "FWZK") && (basDK.GetField("waluta") == "") then
	nRes = 1
	else
		nRes = 0
	endif
	if !dokanul && !CzyEkspBlednyTypFK2(nRes,basDK.GetField("kod"), iSubtyp) then
		EksportZK = 0 // pomijamy
		Exit
	endif
*/	
	if ( basDK.GetField("iddokkoryg") ) then bKorekta = 1
	bRozliczony = ToInt(basDK.GetField(funZnaki("oki")))

	eksport.PoczatekSekcji("Dokument", idDK)

		eksport.Pole("anulowany", using "%d",dokanul)
		eksport.Pole("rodzaj_dok", "zakupu")
//		EksportVATkasowy(idDK)
		iSubtyp = ToInt(basDK.GetField(funZnaki("subtypi")))
		if (iSubtyp == WNT || iSubtyp == FWZ || iSubtyp == FVR || iSubtyp == FKR || iSubtyp == WKZ || iSubtyp == WNK) then
			eksport.Pole("metoda_VAT", "2")
		endif


/////////////////////////////////////////////////////////////////////////////
// nalicz vat
//	definicje z MKP
//	0 - dzie otrzymania
//	1 - dzie wystawienia
//	2 - termin patnoci
//	3 - dzie cakowitego uregulowania nalenoci - bezwarunkowo 
//	4 - dzie cakowitego uregulowania nalenoci ale nie pniej ni po 90 dniach
//	5 - dzie cakowitego uregulowania nalenoci przelewem lub kompensat,  najpniej w cigu 14 dni od wystawienia
//	6 - dzie zapaty nalenoci pod warunkiem zapaty wystawcy faktury
//	7 - dzie cakowitego uregulowania nalenoci przelewem lub kompensat
//	8 - dzie sprzeday 
//	9 - dzie zakupu
//	10 - nie pniej ni po 7 dniach od sprzeday
//	11 - kada zapata
//	12 - kada zapata nie pniej ni po 180 dniach
/////////////////////////////////////////////////////////////////////////////

//	Bya zmiana w przepisach:
//	3      opcja wygasa od 2013-01-01
//	11     opcja dostpna od 2013-01-01

	if (ToInt(basDK.GetField(funZnaki("subtypi"))) == FVR) || (ToInt(basDK.GetField(funZnaki("subtypi"))) == FKR) then
		eksport.Pole("naliczenie_VAT", "5")		//faktura VAT RR
	else
		if (basDK.GetField("flag")&BFLAGdkVATKAS) then
			eksport.Pole("naliczenie_VAT", "11")	//metoda kasowa
		else
			if (Toint(basDK.GetField(funZnaki("subtypi"))) == FVM) || (ToInt(basDK.GetField(funZnaki("subtypi"))) == FKM) then
				eksport.Pole("naliczenie_VAT", "11")	//faktura VAT MP
			else
				eksport.Pole("naliczenie_VAT", "0")		//pozostae
			endif
		endif
	endif



	IF DOODDZIALU THEN
		EksportNotatka(0, basDK.GetField("id"), 34, NOTATKA)
		EksportKodKontrahenta( basDK.GetField("khid"), "kodKH" )
		EksportKodKontrahenta( basDK.GetField("odid"), "kodOdKH" )
		EksportKodMagazynu (basDK.GetField("magazyn"), "")

		EksportRozliczeniaDK(idDK)

		EksportFields(idDK, "DK")
		EksportDanychzPN(idDK)
		EksportKorekt(idDK, "DK")
		EksportDokPozMagazynoweDoHandl(idDK)

		if ( Toint(basDK.GetField(funZnaki("subtypi"))) == WNT || Toint(basDK.GetField(funZnaki("subtypi"))) == WNK ) then
			EksportDokPozFWZdoWNT(idDK)
		endif
		if ( Toint(basDK.GetField(funZnaki("subtypi"))) == FWZ || Toint(basDK.GetField(funZnaki("subtypi"))) == WKZ ) then
			EksportDokPozWNTdoFWZ(idDK)
			strTmp = OdczytajDataZakup( basDK.GetField("id"), basDK.GetField("subtypi") )
			eksport.Pole("dataZakupu", strTmp)	
			strTmp = OdczytajDataObca( basDK.GetField("id"), basDK.GetField("subtypi") )
			eksport.Pole("dataWystawieniaObca", strTmp)
		endif

	ELSE
		eksport.Pole("id", (Using "%l", basDK.GetField("id")))
		eksport.Pole("flag", (Using "%d", basDK.GetField("flag")))
		eksport.Pole("subtyp", ToString(basDK.GetField(funZnaki("subtypi"))))
		eksport.Pole("znacznik", ToString(basDK.GetField(funZnaki("znaczniki"))))
		eksport.Pole("info", basDK.GetField("info"))
		eksport.Pole("osoba", basDK.GetField("osoba"))
		eksport.Pole("kod", basDK.GetField("kod"))
		eksport.Pole("seria", basDK.GetField("seria"))
		eksport.Pole("serianr", (Using "%l", basDK.GetField("serianr")))
		eksport.Pole("okres", (Using "%d", basDK.GetField("okres")))
		eksport.Pole("nazwa", basDK.GetField("nazwa"))
		eksport.Pole("data", basDK.GetField("data"))
		eksport.Pole("data_obcy", basDK.GetField("data_obcy"))
		eksport.Pole("datasp", basDK.GetField("datasp"))
		eksport.Pole("opis", basDK.GetField("opis"))
		eksport.Pole("ok", ToString(basDK.GetField(funZnaki("oki"))))
		eksport.Pole("wplaty", (Using "%.2f", basDK.GetField("wplaty")))
		eksport.Pole("plattyp", ToString(basDK.GetField(funZnaki("plattypi"))))
		eksport.Pole("plattermin", basDK.GetField("plattermin"))
		eksport.Pole("netto", (Using "%.2f", basDK.GetField("netto")))
		eksport.Pole("vat", (Using "%.2f", basDK.GetField("vat")))
		eksport.Pole("odebrane", basDK.GetField("odebrane"))
		eksport.Pole("typ_dk", basDK.GetField("typ_dk"))
		//if (Toint(basDK.GetField(funZnaki("subtypi"))) == FWZ || Toint(basDK.GetField(funZnaki("subtypi"))) == WKZ || Toint(basDK.GetField(funZnaki("subtypi"))) == DIM || Toint(basDK.GetField(funZnaki("subtypi"))) == DKM) then
		if CzyDrugiRejestr(Toint(basDK.GetField(funZnaki("subtypi")))) then
			//eksport.Pole("rejestrVatNal", ToString(basDK.GetField(funZnaki("grupaceni"))))
			eksport.Pole("rejestrVatNal", ToString(basDK.GetField(funZnaki("rejestrVat2"))))
		endif
		//else
		eksport.Pole("grupacen", ToString(basDK.GetField(funZnaki("grupaceni"))))
		//endif
		eksport.Pole("rejestrVat", ToString(basDK.GetField(funZnaki("rejestrVati"))))
		eksport.Pole("wartoscSp", (Using "%.2f", basDK.GetField("wartoscSp")))
		eksport.Pole("waluta", basDK.GetField("waluta"))
		eksport.Pole("kurs", (Using "%.4f", basDK.GetField("kurs")))
		eksport.Pole("zyskdod", (Using "%.2f", basDK.GetField("zyskdod")))
		eksport.Pole("zapas", basDK.GetField("zapas"))
	ENDIF

		eksport.Pole("od_brutto", ToString(!(basDK.GetField(funZnaki("grupaceni")) & 1)))
		eksport.Pole("domylny rabat", (Using "%.2f", basDK.GetField("rabat")))	
		// ???
		eksport.Pole("khKrajKod", PoleKodKraju(basDK.GetField("idKraju")))
		eksport.Pole("khKrajNazwa", PoleNazwaKraju(basDK.GetField("idKraju")))

		eksport.PoczatekPodsekcji("Dane sprzedawcy")
			eksport.Pole("khid", (Using "%l", basDK.GetField("khid")))
			basKH.GetRecById(basDK.GetField("khid"))
			eksport.Pole("fk_ident", basKH.GetField("khfk"))
			eksport.Pole("khkod", basDK.GetField("khkod"))
			eksport.Pole("khnazwa", basDK.GetField("khnazwa"))
			eksport.Pole("khadres", basDK.GetField("khadres"))
			eksport.Pole("khdom", basDK.GetField("khdom"))
			eksport.Pole("khlokal", basDK.GetField("khlokal"))
			eksport.Pole("khmiasto", basDK.GetField("khmiasto"))
			eksport.Pole("khkodpocz", basDK.GetField("khkodpocz"))
			eksport.Pole("khnip", basDK.GetField("khnip"))

			eksport.Pole("khKrajKod", PoleKodKraju(basDK.GetField("idKraju")))
			eksport.Pole("khKrajNazwa", PoleNazwaKraju(basDK.GetField("idKraju")))

			if 0 != basDK.GetField("khid") then
				EksportKH(basDK.GetField("khid"))
			endif
		eksport.KoniecSekcji() //"Dane sprzedawcy"

		eksport.PoczatekPodsekcji("Dane dostawcy")
			eksport.Pole("odid", (Using "%l", basDK.GetField("odid")))
			eksport.Pole("odkod", basDK.GetField("odkod"))
			eksport.Pole("odnazwa", basDK.GetField("odnazwa"))
			eksport.Pole("odadres", basDK.GetField("odadres"))
			eksport.Pole("oddom", basDK.GetField("oddom"))
			eksport.Pole("odlokal", basDK.GetField("odlokal"))
			eksport.Pole("odmiasto", basDK.GetField("odmiasto"))
			eksport.Pole("odkodpocz", basDK.GetField("odkodpocz"))
			if 0 != basDK.GetField("odid") then
				EksportKH(basDK.GetField("odid"))
			endif
		eksport.KoniecSekcji() //"Dane dostawcy"

		// "symbol FK" i "obsuguj jak"
		eksport.Pole("symbol FK", symbolFK)
		eksport.Pole("obsluguj jak", obslugujJak)

		// numer i data dokumentu korygowanego
		basDK2.GetRecById(basDK.GetField("iddokkoryg"))
		strTmp = basDK2.GetField("kod_obcy")
		strTmp += " ["
		strTmp += basDK2.GetField("kod")
		strTmp += "]"
		strTmp = Mid(strTmp, 1, iif(len(strTmp)>LEN_NRDK,LEN_NRDK,len(strTmp)))
		eksport.Pole("NazwaKor", strTmp)
		eksport.Pole("DataObcyKor", basDK2.GetField("data_obcy"))
		eksport.Pole("DataKor", basDK2.GetField("datasp"))

		strTmp = PoleRejestr(10700, Toint(basDK.GetField(funZnaki("rejestrVati"))), '\n')
		eksport.Pole("rejestr_vat", GetNthElement(1, strTmp, '\n'))
		eksport.Pole("nazwa_rejestru_vat", GetNthElement(2, strTmp, '\n'))
		eksport.Pole("typ_rejestru_vat", GetNthElement(3, strTmp, '\n'))

    	if ( Toint(basDK.GetField(funZnaki("subtypi"))) != FWZ && Toint(basDK.GetField(funZnaki("subtypi"))) != WKZ) then   //pomijamy faktury wewntrzne
			eksport.Pole("rejestr_platnosci", PoleRejestrPlatnosci(Toint(basDK.GetField(funZnaki("plattypi")))))
			eksport.Pole("forma_platnosci", PoleFormaPlatnosci(basDK.GetField("formaplatn")))
        endif

		if CzyDrugiRejestr( Toint(basDK.GetField(funZnaki("subtypi")))) then
			//strTmp = PoleRejestr(10500, Toint(basDK.GetField(funZnaki("grupaceni"))), '\n')
			strTmp = PoleRejestr(10500, Toint(basDK.GetField(funZnaki("rejestrVat2"))), '\n')

			eksport.Pole("rejestr_vatNal", GetNthElement(1, strTmp, '\n'))
			eksport.Pole("nazwa_rejestru_vatNal", GetNthElement(2, strTmp, '\n'))
			eksport.Pole("typ_rejestru_vatNal", GetNthElement(3, strTmp, '\n'))
		endif
		// sekcja magazyn
		EksportMagazyn(basDK.GetField("magazyn"))

		PoleKatalog(basDK.GetField("katalog"), 2600)
		PoleRodzaj(basDK.GetField("rodzaj"))
		ExportSplitPaymentStuff(1, basDK.GetField("checkWL"), basDK.GetField("splitPayment"), basDK.GetField("forceSP"), basDK.GetField("account"))
		eksport.Pole("JPK_V7", basDK.GetField("JPK_V7"))

		// pozycje dokumentu
		basDP.SetKey("super")
		basDP.SetKeySeg("super", idDK)
		err = basDP.GetRec(GE)
		while !err && basDP.GetKeySeg("super") == idDK		
			iStVat = Toint(basDP.GetField(funZnaki("stvati")))
			sRej = ToString(basDP.GetField(funZnaki("rejestrVati")))
			lSuper = 10700
			sRejVat=""
			sRejVatNazw=""
			iRejVatRodz=-1
			strTmp = PoleRejestr(lSuper, basDP.GetField(funZnaki("rejestrVati")), '\n')
			sRejVat = GetNthElement(1, strTmp, '\n')
			sRejVatNazw = GetNthElement(2, strTmp, '\n')
			iRejVatRodz = Val(GetNthElement(5, strTmp, '\n'))
			lABC = Val(GetNthElement(6, strTmp, '\n'))
			sJPK_V7 = basDP.GetField("JPK_V7")

			if !CzyStNP(ToInt(basDP.GetField(funZnaki("stvati")))) then 
				if basDP.GetField("vat50") then
					nettoNP = Round(basDP.GetField("wartNetto")/ 2)
					vatNP = Round(basDP.GetField("wartVat")/ 2)
					wnettoNP = Round(basDP.GetField("walNetto") /2)
					wbruttoNP = Round(basDP.GetField("walBrutto") / 2)
					TabRejVat.Wstaw(Val(sRej), sRejVat, sRejVatNazw, iRejVatRodz, iStVat, basDP.GetField("wartNetto")-nettoNP, basDP.GetField("wartVat")-vatNP, 0, basDP.GetField("walNetto")-wnettoNP, basDP.GetField("walBrutto")-wbruttoNP, lABC, 1, sJPK_V7)
					buf = sRejestry
					if find regular strRex then 
						sRej = regular 2
						lSuper = 10700
						sRejVat=""
						sRejVatNazw=""
						iRejVatRodz=-1
						strTmp = PoleRejestr(lSuper, Val(sRej), '\n')
						sRejVat = GetNthElement(1, strTmp, '\n')
						sRejVatNazw = GetNthElement(2, strTmp, '\n')
						iRejVatRodz = Val(GetNthElement(5, strTmp, '\n'))
						lABC = Val(GetNthElement(6, strTmp, '\n'))
						iStVat = StawkaNP()
						TabRejVat.Wstaw(Val(sRej), sRejVat, sRejVatNazw, iRejVatRodz, iStVat, 0, 0, nettoNP+vatNP, wbruttoNP, wbruttoNP, lABC, 1, sJPK_V7)
					endif
				else
					TabRejVat.Wstaw(Val(sRej), sRejVat, sRejVatNazw, iRejVatRodz, iStVat, basDP.GetField("wartNetto"), basDP.GetField("wartVat"), 0, basDP.GetField("walNetto"), basDP.GetField("walBrutto"), lABC, 1, sJPK_V7)
				endif
			else
				TabRejVat.Wstaw(Val(sRej), sRejVat, sRejVatNazw, iRejVatRodz, iStVat, 0, 0, basDP.GetField("wartNetto"), basDP.GetField("walNetto"), basDP.GetField("walBrutto"),lABC, 1, sJPK_V7)
			endif

			iSubtyp = ToInt(basDK.GetField(funZnaki("subtypi")))
			if CzyDrugiRejestr(iSubtyp) then
				
				//sRej = ToString(basDP.GetField(funZnaki("grupaceni")))
				sRej = ToString(basDP.GetField(funZnaki("rejestrVat2")))

				lSuper = 10500
				sRejVat=""
				sRejVatNazw=""
				iRejVatRodz=-1
				strTmp = PoleRejestr(lSuper, Val(sRej), '\n')
				if strTmp != "" then
					sRejVat = GetNthElement(1, strTmp, '\n')
					sRejVatNazw = GetNthElement(2, strTmp, '\n')
					iRejVatRodz = Val(GetNthElement(5, strTmp, '\n'))
					lABC = Val(GetNthElement(6, strTmp, '\n'))
					if !CzyStNP(ToInt(basDP.GetField(funZnaki("stvati")))) then 
						TabRejVat.Wstaw(Val(sRej), sRejVat, sRejVatNazw, iRejVatRodz, iStVat, basDP.GetField("wartNetto"), basDP.GetField("wartVat"), 0, basDP.GetField("walNetto"), basDP.GetField("walBrutto"), lABC, 0, sJPK_V7)
					else
						TabRejVat.Wstaw(Val(sRej), sRejVat, sRejVatNazw, iRejVatRodz, iStVat, 0, 0, basDP.GetField("wartNetto"),basDP.GetField("walNetto"), basDP.GetField("walBrutto"),lABC, 0, sJPK_V7)
					endif
				endif
			endif

			eksport.PoczatekPodsekcji(szSectionPosDok)
	IF DOODDZIALU THEN
				EksportNotatka(0, basDP.GetField("id"), 18, NAZWA)
				EksportKodTowaru( basDP.GetField("idtw") )
				EksportKodKontrahenta( basDP.GetField("idkh"), "kodKH" )
				EksportKodMagazynu (basDP.GetField("magazyn"), "")
				EksportFields(basDP.GetField("id"), "DP")
	ELSE
				eksport.Pole("flag", (Using "%d", basDP.GetField("flag")))
				eksport.Pole("subtyp", ToInt(basDP.GetField(funZnaki("subtypi"))))
				eksport.Pole("lp", (Using "%d", basDP.GetField("lp")))
				eksport.Pole("kod", basDP.GetField("kod"))
				eksport.Pole("data", basDP.GetField("data"))
				eksport.Pole("opis", basDP.GetField("opis"))
				eksport.Pole("ilosc", (Using "%.4f", basDP.GetField("ilosc")))
	
				eksport.Pole("jm", basDP.GetField("jm"))
				eksport.Pole("grupacen", ToString(basDP.GetField(funZnaki("grupaceni"))))
				eksport.Pole("cenaBaza", (Using "%.2f", basDP.GetField("cenaBaza")))
				eksport.Pole("waluta", basDP.GetField("waluta"))
				eksport.Pole("cenaBazaPl", (Using "%.2f", basDP.GetField("cenaBazaPl")))
				eksport.Pole("cena", (Using "%.2f", basDP.GetField("cena")))
				eksport.Pole("wartNetto", (Using "%.2f", basDP.GetField("wartNetto")))
				eksport.Pole("wartVat", (Using "%.2f", basDP.GetField("wartVat")))
				eksport.Pole("wartTowaru", (Using "%.2f", basDP.GetField("wartTowaru")))
				eksport.Pole("cenabaztow", (Using "%.2f", basDP.GetField("cenabaztow")))
				eksport.Pole("walcenybaz", basDP.GetField("walcenybaz"))
				eksport.Pole("rejestrVAT", ToString(basDP.GetField(funZnaki("rejestrVati"))))
				eksport.Pole("rejestrVAT2", ToString(basDP.GetField(funZnaki("rejestrVat2"))))
#ifndef LITE
				eksport.Pole("magazyn", (Using "%d", basDP.GetField("magazyn")))
#endif
				eksport.Pole("wartstvat", (Using "%d", basDP.GetField("wartstvat")))
				eksport.Pole("zyskdod", (Using "%.2f", basDP.GetField("zyskdod")))
				eksport.Pole("iloscjedn", (Using "%.4f", basDP.GetField("iloscjedn")))
	ENDIF
				EksportStVAT(ToInt(basDP.GetField(funZnaki("stvati"))))
				strTmp = PoleRejestr(10700, ToInt(basDP.GetField(funZnaki("rejestrVati"))), '\n')
				eksport.Pole("rejestr_vat", GetNthElement(1, strTmp, '\n'))
				eksport.Pole("nazwa_rejestru_vat", GetNthElement(2, strTmp, '\n'))
				eksport.Pole("typ_rejestru_vat", GetNthElement(3, strTmp, '\n'))
				eksport.Pole("SWW/KWiU", basDP.GetField("opisdod"))
				eksport.Pole("JPK_V7", basDP.GetField("JPK_V7"))

				if CzyDrugiRejestr(Toint(basDK.GetField(funZnaki("subtypi")))) then
					//strTmp = PoleRejestr(10500, ToInt(basDP.GetField(funZnaki("grupaceni"))), '\n')
					strTmp = PoleRejestr(10500, ToInt(basDP.GetField(funZnaki("rejestrVat2"))), '\n')
					eksport.Pole("rejestr_vatNal", GetNthElement(1, strTmp, '\n'))
					eksport.Pole("nazwa_rejestru_vatNal", GetNthElement(2, strTmp, '\n'))
					eksport.Pole("typ_rejestru_vatNal", GetNthElement(3, strTmp, '\n'))
					eksport.Pole("SWW/KWiUNal", basDP.GetField("opisdod"))
				endif

				eksport.Pole("typ_pozycji", PoleTypPozycji(basDP.GetField("flag")))
				If !DOODDZIALU && CzyCechaOO( basDK.GetField( "subtypi" ) ) Then
					eksport.Pole( "odwrotneObc", ( Using "%d", basDP.GetField( "odwrotneObc" ) ) )
				EndIf

				DodajDoOpisu(basDP.GetField("opis"), "/")

				if 0 != basDP.GetField("idtw") then
					EksportTW(basDP.GetField("idtw"), basDP.GetField("kod"))
				endif

//				dKwotaWal += Round(basDP.GetField("cenawal") * basDP.GetField("iloscwp"), 2)

			eksport.KoniecSekcji() //"Pozycja dokumentu"
			err = basDP.GetRec(NX)
		wend

		//////////////////////////////////////////////////////
		// numer dokumentu w FK
		strTmp = OdczytajKodObcy( basDK.GetField("id"), basDK.GetField("subtypi"), basDK.GetField("kod_obcy") )
		strTmp += " ["
		strTmp += basDK.GetField("kod")
		strTmp += "]"
		strTmp = Mid(strTmp, 1, iif(len(strTmp)>LEN_NRDK, LEN_NRDK, len(strTmp)))
		eksport.Pole("FK nazwa", strTmp)

		eksport.Pole("Datawpl", basDK.GetField("datawp"))

		obl.Add(BAS_ZK, idDK)

		eksport.Pole("opis FK",	obl.Tresc)

		if CzyWalutowy(idDK) then
			dKwotaWal = GetKwotaNaleznosciWal(idDK)
			dKwotaWal *= -1
			
			if(obslugujJak == "FWZ" || obslugujJak == "FWZK")  then //nowy typ dokumentu w FK - wielowalutowy
				eksport.PoczatekPodsekcji("AtrybutWaluta")
					eksport.Pole("kurs", (Using "%.6f", dKursDoch))
					eksport.Pole("waluta", basDK.GetField("waluta"))
					eksport.Pole("dane","kurs CIT/PIT")
				eksport.KoniecSekcji() //"AtrybutWaluta"
				eksport.PoczatekPodsekcji("AtrybutWaluta")
					eksport.Pole("kurs", (Using "%.6f", dKurs))
					eksport.Pole("waluta", basDK.GetField("waluta"))
					eksport.Pole("dane","kurs VAT")
				eksport.KoniecSekcji() //"AtrybutWaluta"
				eksport.Pole("wkwota", (Using "%.2f", Round(dKwotaWal,1)))
			else
				dKurs = basDK.GetField("kurs")
				eksport.Pole("kurs", (Using "%.6f", dKurs))
				eksport.Pole("waluta", basDK.GetField("waluta"))
				eksport.Pole("wkwota", (Using "%.2f", Round(dKwotaWal,2)))
				//dKwota = Round(dKwotaWal * dKurs, 2)
				//eksport.Pole("kwota", (Using "%.2f", dKwota))
			endif
		endif

		iSubtyp = ToInt(basDK.GetField(funZnaki("subtypi")))
		if iSubtyp == DIM || iSubtyp == DKM || iSubtyp == WNT || iSubtyp == WNK then
			// w tym wypadku dKwota zawiera ca, akcyzy i inne, a nie powinna

			dKwota = 0
			if obl.GetFirstZap() then
				Do
					if obl.StronaZap == "WN" then
						dKwota += obl.KwotaZap
					endif
				Loop While ( obl.GetNextZap() )
			endif

			eksport.Pole("kwota", (Using "%.2f", Round(dKwota,2)))
		else
			dKwota = basDK.GetField("netto") + basDK.GetField("vat")
			eksport.Pole("kwota", (Using "%.2f", (-1)*Round(dKwota,2)))
		endif
		nLastZap = ZapiszZAP(obl, 0, 0, CzyWalutowy(idDK), basDK.GetField("waluta"), basDK.GetField("kurs"))

#ifdef HMHL
		// rwnolege ksigowania magazynowe
		Shrink tIdMG, -1
		tIdMG(1) = 0

		if iOpcje & ROWNOLEGLE_KSIEG_MAG then

			nCount += 1

			//jezeli jest to faktura wewnetrzna
			if iSubTyp == FWZ || iSubTyp == WKZ then
				lSuper = VAL(basDK.GetField("odebrane"))
				if lSuper then			//szukamy dok magazynowego
				
					if ( basZZ.Open() ) then PrintError("Bd otwarcia bazy ZZ")
					
					basZZ.SetKey("cross1")
					basZZ.SetKeySeg(funZnaki("typi"), Field(151))			
					basZZ.SetKeySeg("baza1", 34)		// baza
					basZZ.SetKeySeg("id1",   idDK)			// id 
					basZZ.SetKeySeg("baza2", 33)
					
					err = basZZ.GetRec(GE)
					if !err && basZZ.GetKeySeg(funZnaki("typi")) == Field(151) && basZZ.GetKeySeg("baza1") == 34 && basZZ.GetKeySeg("id1") == idDK && basZZ.GetKeySeg("baza2") == 33 then
						basMG.SetKey("id")
						basMG.SetKeySeg("id", basZZ.GetKeySeg("id2"))	
						if !basMG.GetRec(EQ) then
							if ( (iOpcje & NIE_EKSP_OZNAK) && !isSD && (ToInt(basMG.GetField(funZnaki("exp_fki"))) & 0x01) ) then
								eksport.AddInfo("Nie mona powtrnie wyeksportowa zapisw do dokumentu " + basMG.GetField("kod") + ".")
							else
								if EkspZatwWart(basMZ, basPW, basMG.GetField("id"), basMG.GetField("kod"), basDK.GetField("kod")) then

									obl.Add(BAS_MG, basMG.GetField("id"))

									tIdMG(size(tIdMG)) = basMG.GetField("id")
									grow tIdMG, 1
									MgId = basMG.GetField("id")
								endif
							endif
						endif
					endif
					basZZ.close()
				endif
			else
				// dokumenty magazynowe rozliczajce dokument handlowy
				basMG.SetKey("idhandl")
				basMG.SetKeySeg("idhandl", idDK)
				err = basMG.GetRec(GE)
				while !err && basMG.GetKeySeg("idhandl") == idDK
					if ( (iOpcje & NIE_EKSP_OZNAK) && !isSD && (ToInt(basMG.GetField(funZnaki("exp_fki"))) & 0x01) ) then
						eksport.AddInfo("Nie mona powtrnie wyeksportowa zapisw do dokumentu " + basMG.GetField("kod") + ".")
					else
						if EkspZatwWart(basMZ, basPW, basMG.GetField("id"), basMG.GetField("kod"), basDK.GetField("kod")) then

							obl.Add(BAS_MG, basMG.GetField("id"))

							tIdMG(size(tIdMG)) = basMG.GetField("id")
							grow tIdMG, 1

						endif
					endif

					err = basMG.GetRec(NX)
				wend
			endif
			if(obslugujJak == "FWZ" || obslugujJak == "FWZK")  then //nowy typ dokumentu w FK - wielowalutowy
			//ewentualne rownolegle ksiegowanie magazynowe tylko w PLN
				ZapiszZAP(obl, 1, nLastZap+1, 0, "", 0)
			else
				ZapiszZAP(obl, 1, nLastZap+1, CzyWalutowy(idDK), basDK.GetField("waluta"), basDK.GetField("kurs"))
			endif
		endif // rwnolege ksigowania magazynowe
#endif

		// rejestry VAT
		iSubtyp = ToInt(basDK.GetField(funZnaki("subtypi")))
		RejestryVAT(idDK, iSubtyp, basDK.GetField("formaplatn"), basDK.GetField("datarej"), obslugujJak)

		ZapiszTRAROZ(obl, 0, basDK.GetField("kurs"))
		ZapiszETRANSFERS(idDK, obl)
		obl.Clear()
	eksport.KoniecSekcji() //"Dokument"

#ifdef HM
IF DOODDZIALU THEN
	// Eksport dokumentw magazynowych z oddziau
	For i = 1 To i > Size(tIdMG)
		EksportOddzDokMG(tIdMG(i))
	Next i
ENDIF
#endif
EndSub
